import './annotations.dart';
import './preconditions.dart';
import './pair.dart';

class Maps {
  static bool isNullOrEmpty<K, V>(@nullable Map<K, V> map) {
    return map == null || map.isEmpty;
  }

  static Map<K, V> fromPairs<K, V>(@nonNull Iterable<Pair<K, V>> iterable) {
    checkNotNull(iterable);
    return Map.fromEntries(iterable.map((t) => MapEntry(t.first, t.second)));
  }
}
