class NotImplementedError extends Error {
  final Object message;

  NotImplementedError([this.message = "An operation is not implemented."]);

  @override
  String toString() {
    return message.toString();
  }
}

/// Always throws [NotImplementedError] stating that operation is not implemented.
/// [reason] is a string explaining why the implementation is missing.
TODO(String reason) =>
    throw NotImplementedError("An operation is not implemented: $reason");

R run<R>(R block()) => block();

R let<T, R>(T receiver, R block(T t)) {
  return block(receiver);
}

/// Executes the given function [action] specified number of [times]
repeat(int times, action(int index)) {
  for (int i = 0; i < times; i++) {
    action(i);
  }
}
